package org.zkoss.zk.richlet;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.eclipse.pmf.wazaabi.engine.core.editparts.WidgetEditPart;
import org.eclipse.pmf.wazaabi.engine.core.editparts.factories.ComposedEditPartFactory;
import org.eclipse.pmf.wazaabi.engine.zk.editparts.WazaabiEditPartFactory;
import org.eclipse.pmf.wazaabi.engine.zk.nonosgi.ZKHelper;
import org.eclipse.pmf.wazaabi.engine.zk.viewers.ZKControlViewer;
import org.eclipse.pmf.wazaabi.engine.zk.views.ZKXulElementCtrlView;
import org.eclipse.pmf.wazaabi.model.core.widgets.AbstractContainer;
import org.eclipse.pmf.wazaabi.model.zk.widgets.Button;
import org.eclipse.pmf.wazaabi.model.zk.widgets.Label;
import org.eclipse.pmf.wazaabi.model.zk.widgets.Panel;
import org.eclipse.pmf.wazaabi.model.zk.widgets.Textbox;
import org.eclipse.pmf.wazaabi.model.zk.widgets.WidgetsFactory;
import org.zkoss.zk.ui.GenericRichlet;
import org.zkoss.zk.ui.Page;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zk.ui.event.Events;
import org.zkoss.zul.Window;


public class ZKRichlet extends GenericRichlet {
    
    public void service(Page page) 
    {
        page.setTitle("Richlet Test");
 
        final Window w = new Window("ZK Framework Test on Wazaabi", "normal", false);   
   
        w.setPage(page);
        
		
        ZKHelper.init();
        
		
        // create viewer
		ZKControlViewer viewer = new ZKControlViewer(w);
		
		//------------------------------------------------------------------
		// EMF requirements for standalone applications
		Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put(
				"zkmodel", new XMIResourceFactoryImpl());
		org.eclipse.pmf.wazaabi.model.zk.widgets.WidgetsPackage.eINSTANCE.eClass();

		// load the EMF resource
		Resource resource = new ResourceSetImpl().getResource(URI
				.createURI("models/ZKRichlet.zkmodel"), true);

		viewer.setContents(resource.getEObject("/"));
		
		//------------------------------------------------------------------
        //Creating components by hand 		
//		Panel panel = WidgetsFactory.eINSTANCE.createPanel();
//		Textbox text = WidgetsFactory.eINSTANCE.createTextbox(); 
//		text.setText("enter text here");
//		final Label label = WidgetsFactory.eINSTANCE.createLabel(); 
//		label.setText("hello wazaabi!");
//		
//		Button button = WidgetsFactory.eINSTANCE.createButton();
//		button.setText("ZK BUTTON");
//	   //onClick Event - changing label
//		final org.zkoss.zul.Button button2 = new org.zkoss.zul.Button("Change Label"); 
//		button2.addEventListener(Events.ON_CLICK,
//				new EventListener() {
//			public void onEvent(Event evt) {
//				label.setText("Goodbye wazaabi!");
//				}
//			});
//		
//		button2.setParent(w);
//		label.setParent(panel);
//		text.setParent(panel);
//		button.setParent(panel);

	
	
		
		// start rendering with panel as context
		//viewer.setContents(panel);
		
		

    }
}
